#!/usr/bin/python

# Editor

import wx
import sys

ID_NEW = wx.ID_NEW
ID_OPEN = wx.ID_OPEN
ID_REVERT = wx.ID_REVERT
ID_CLOSE = wx.ID_CLOSE
ID_SAVE = wx.ID_SAVE
ID_SAVEAS = wx.ID_SAVEAS
ID_PRINT = wx.ID_PRINT
ID_EXIT = wx.ID_EXIT
ID_ABOUT=wx.ID_ABOUT
ID_HELP=wx.ID_HELP

class XFrame(wx.Frame):
    def __init__(self, parent,title):
        wx.Frame.__init__(self, parent,title='simple ed',size=(600,400),style=wx.DEFAULT_FRAME_STYLE)
        self.control=wx.TextCtrl(self,style=wx.TE_MULTILINE)
        self.CreateStatusBar()

        menubar=self.MenbuBars()
        self._toolBar = self.CreateToolBar( wx.TB_HORIZONTAL | wx.NO_BORDER | wx.TB_FLAT 
		| wx.TB_TEXT )
        #self.AddSimpleTool(ID_NEW, ("New"), ("Start a New File"))
        self._toolBar.AddSimpleTool(ID_NEW,wx.ArtProvider.GetBitmap(str(wx.ART_NEW), wx.ART_TOOLBAR), 'New', '')
        #self._toolBar.AddSimpleTool(ID_OPEN,wx.ART_FILE_OPEN, 'Open', '')
        self._toolBar.AddSimpleTool(ID_OPEN,wx.ArtProvider.GetBitmap(str(wx.ART_FILE_OPEN), wx.ART_TOOLBAR), 'Open', '')
        self._toolBar.Realize()
        self._toolBar.Show(wx.ConfigBase_Get().ReadInt("ViewToolBar", True))

       
        self.doBind()
        
        self.SetMenuBar(menubar)
    def AddSimpleTool1(self, tool_id, lbl, helpstr):
        """Overides the default function to allow for easier tool
        generation/placement by automatically getting an appropriat icon from
        the art provider.
        @param tool_id: Id of tool to add
        @param lbl: tool lable
        @param helpstr: tool help string

        """
        #if self.GetToolBitmapSize() == (16, 16):
            #client = wx.ART_MENU
        #else:
        client = wx.ART_TOOLBAR
        tool_bmp = wx.ArtProvider.GetBitmap(str(tool_id), client)
        wx.ToolBar.AddSimpleTool(self, tool_id, tool_bmp, (lbl), (helpstr))

    def MenbuBars(self):
        menubar=wx.MenuBar(style=wx.MENU_TEAROFF)
        m_file=wx.Menu()
        menubar.Append(m_file,"&File")
        
        m_file.Append(ID_NEW,"&New \tCtrl+N'","New file")
        m_file.Append(ID_OPEN,"&Open... \tCtrl+O","Open file")
        m_file.AppendSeparator()
        m_file.Append(ID_CLOSE,"&Close \tCtrl+W","Close file")
        m_file.AppendSeparator()
        m_file.Append(ID_SAVE, '&Save... \tCtrl+S',
                 'Save file')
        m_file.Append(ID_SAVEAS, 'Save &As \tCtrl+Shift+S',
                 'Save file with new name')
        m_file.AppendSeparator()
        m_file.Append(ID_EXIT,"E&xit","Exit now")
     
        mh=wx.Menu()
        
       
        mh.Append(ID_ABOUT,"&About","Find all about ...")
        mh.AppendSeparator()
        mh.Append(ID_HELP,"&Help","Help for ed")

        menubar.Append(mh,"&Help")

        return menubar

    def doBind(self):
        self.Bind(wx.EVT_MENU,self.OnQuit, id=ID_EXIT)
        self.Bind(wx.EVT_MENU,self.OnOpen, id=ID_OPEN)
        self.Bind(wx.EVT_MENU,self.OnNew, id=ID_NEW)
        self.Bind(wx.EVT_MENU,self.OnAbout, id=ID_ABOUT)
    def OnQuit(self,event):
        self.Close()
    def OnOpen(self,event):
        print "Open file"
        filed= wx.FileDialog(self,message = 'Choose an file to open',
                        defaultDir = '',defaultFile = '',wildcard = '*.py;*.txt',
                        style = wx.OPEN)
        if filed.ShowModal() == wx.ID_OK:
            self.path = filed.GetPath()
            self.control.LoadFile(self.path)
    def OnNew(self,event):
        self.control.Clear()
    def OnAbout(self,event):
        wx.MessageBox(message="Napisano na satovima KS",caption="KS simple ed",style=wx.OK|wx.CENTRE)

class App(wx.App):
    def OnInit(self):
        frame=XFrame(parent=None,title='bare')
        if len(sys.argv) > 1 :
            try:
                frame.control.LoadFile(sys.argv[1])
            except:
                print "Can't load file", sys.argv[1]
                exit(1)
        frame.Show()
        return True

if __name__ == "__main__":
    editor=App();
    editor.MainLoop();